﻿{ 
   //Functions used by this script. 
   function processFile (theFile)
   { 
      writeLn("Processing file: " + theFile.name); 
      try
      { 
         var importOptions = new ImportOptions (theFile); //create a variable containing ImportOptions 
         importSafeWithError (importOptions); 
      } 
      catch( error ) 
      { 
         // display errors. 
         //writeLn(error); 
      } 
   } 
    

   function importSafeWithError (importOptions) 
   { 
      try 
      { 
         app.project.importFile (importOptions); 
      } catch (error) 
      { 
         //alert(error.toString() + importOptions.file.fsName); 
      } 
   } 

   function processFolder(theFolder) 
   { 
      var files = theFolder.getFiles(); //Get an array of files in the target folder 
          
      for (index in files) 
      { //Go through the array and set each element to singleFile, then run the following 
         if (files[index] instanceof File && files[index].name != ".DS_Store") 
         { 
            processFile (files[index]); //calls the processFile function above 
         } else if (files[index] instanceof Folder) 
         { 
            processFolder (files[index]); // recursion 
         } 
      } 
   } 
   
   // global variables
   var mainLayer, alphaLayer;
   var compW, compH, compL, compRate, compBG, compPixelAspect;
   var myItemCollection, tempCollection, myCompName, myComp;

   //Ask the user for a folder whose contents are to be imported 
   var targetFolder = folderGetDialog("Import Items from Folder..."); //returns a folder or null 
   if (targetFolder) 
      { 
      //Begin the script by creating an undo group. 
      app.beginUndoGroup("Process Folder Of Track Mattes"); 
         
      //Create project if necessary. 
      var proj = app.project; 
      if(!proj) proj = app.newProject(); 
             
      //Import folder items into the project window. 
      processFolder(targetFolder); 
             
      //Take advantage of the fact that after footage is imported, it is selected in the project window.
      var projSelection = app.project.selection;   //Set selected import items to an array. 
      var myCount = 1; 

      //Add footage items from the project window to the composition. 
      for (i=0; i < projSelection.length; i++) 
      {                                       //loop through and add layers to comp 
         //Create new comp for this footage item. 
         compW = projSelection[i].width; // comp width 
         compH = projSelection[i].height; // comp height 
         compL = projSelection[i].duration;  // comp length (seconds) 
         compRate = projSelection[i].frameRate; // comp frame rate 
         compBG = [48/255,63/255,84/255] // comp background color 
         compPixelAspect = projSelection[i].pixelAspect; // pixel aspect ratio

         myItemCollection = app.project.items; 
         myCompName = projSelection[i].name;   //'my track matte comp'+myCount 
         myComp = myItemCollection.addComp(myCompName,compW,compH,compPixelAspect,compL,compRate); 
         myComp.bgColor = compBG;              
             
         //Add to comp 
         if(projSelection[i] instanceof FootageItem) 
         {      //test to be sure it's not a comp or folder 
            tempCollection = myComp.layers;      //variable for collection of layer objects in the comp 
            mainLayer = tempCollection.add(projSelection[i]);      //Add diffuse layer. 
            alphaLayer = tempCollection.add(projSelection[i+1]);      //Add alpha layer, assume it was imported right after the diffuse layer. 
            var presetPath = "/Applications/Adobe After Effects CS4/Presets/Custom/keylight_test1.ffx";
            var myPreset = File(presetPath);
            alphaLayer.applyPreset(myPreset);
               } 
            
         //Make our loop step by 2 to skip adding the alpha again. 
         i++; 
         myCount++; 
            
      }       
      app.endUndoGroup(); 
   }
}